// Generated by CoffeeScript 1.9.1
'use strict';
var addDeprecatedOpts, aliases, buildCmd, commands, program, watchCmd,
  indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

program = require('commander');

commands = require('./');

aliases = {
  n: 'new',
  b: 'build',
  w: 'watch'
};

Object.keys(aliases).forEach(function(key) {
  var value;
  value = aliases[key];
  return aliases[value] = value;
});

program.version(require('../package.json').version).usage('[command] [options]');

program.command('new [skeleton] [path]').description('Create new brunch project in path [.]. Short-cut: n').action(function() {
  return commands["new"](program.args[0], program.args[1]);
});

buildCmd = program.command('build [path]').description('Build a brunch project. Short-cut: b').option('-e, --env [setting]', 'specify a set of override settings to apply').option('-P, --production', 'same as `--env production`').option('-d, --debug', 'print verbose debug output to stdout').action(commands.build);

watchCmd = program.command('watch [path]').description('Watch brunch directory and rebuild if something changed. Short-cut: w').option('-e, --env [setting]', 'specify a set of override settings to apply').option('-P, --production', 'same as `--env production`').option('-s, --server', 'run a simple http server that would serve public dir').option('-p, --port [port]', 'if a `server` option was specified, define on which port the server would run').option('-d, --debug', 'print verbose debug output to stdout').action(commands.watch);

addDeprecatedOpts = function() {
  return [buildCmd, watchCmd].forEach(function(cmd) {
    return cmd.option('-c, --config [path]', '[DEPRECATED] path to config files').option('-o, --optimize', '[DEPRECATED] same as `--env production`');
  });
};

exports.run = function() {
  var args, cmd, command;
  args = process.argv.slice();
  command = args[2];
  if (indexOf.call(args, '-c') >= 0 || indexOf.call(args, '--config') >= 0) {
    console.error('--config is deprecated. Use `-e / --environment` and custom envs in config');
    addDeprecatedOpts();
  }
  if (indexOf.call(args, '-o') >= 0 || indexOf.call(args, '--optimize') >= 0) {
    console.error('--optimize is deprecated. Use `-P / --production`');
    addDeprecatedOpts();
  }
  if (command === 'g' || command === 'd' || command === 'generate' || command === 'destroy') {
    console.error('`brunch generate / destroy` command was removed.\n\nUse scaffolt (https://github.com/paulmillr/scaffolt)\nsuccessor or similar:\n    npm install -g scaffolt\n    scaffolt <type> <name> [options]\n    scaffolt <type> <name> [options] --revert');
  }
  if (command === 't' || command === 'test') {
    console.error('`brunch test` command was removed.\n\nUse mocha-phantomjs (http://metaskills.net/mocha-phantomjs/)\nsuccessor or similar:\n    npm install -g mocha-phantomjs\n    mocha-phantomjs [options] <your-html-file-or-url>');
  }
  if ((command === 'n' || command === 'new') && indexOf.call(args, '--skeleton') >= 0) {
    return console.error('`--skeleton` option has been removed from `brunch new`.\n\nThe syntax is now simply:\n\nbrunch new <path-or-URI> [optional-output-dir]\nbrunch new github:brunch/dead-simple\nbrunch new gh:paulmillr/brunch-with-chaplin');
  }
  cmd = aliases[command];
  if (cmd) {
    args[2] = cmd;
  }
  program.parse(args);
  if (!cmd) {
    return program.help();
  }
};
